import type { Schema, ValidateFunction } from "../types";
import type Ajv from "../ajv";
import { Name } from "./codegen";
import { LocalRefs } from "./resolve";
export interface SchemaRefs {
    [ref: string]: Schema | ValidateFunction | undefined;
}
interface SchemaEnvArgs {
    schema: Schema;
    root?: SchemaEnv;
    baseId?: string;
    localRefs?: LocalRefs;
    meta?: boolean;
    cacheKey?: unknown;
}
export declare class SchemaEnv implements SchemaEnvArgs {
    readonly schema: Schema;
    readonly root: SchemaEnv;
    baseId: string;
    localRefs?: LocalRefs;
    readonly meta?: boolean;
    readonly cacheKey?: unknown;
    readonly $async?: boolean;
    readonly refs: SchemaRefs;
    validate?: ValidateFunction;
    validateName?: Name;
    constructor(env: SchemaEnvArgs);
}
export declare function compileSchema(this: Ajv, sch: SchemaEnv): SchemaEnv;
export declare function resolveRef(this: Ajv, root: SchemaEnv, baseId: string, ref: string): Schema | ValidateFunction | SchemaEnv | undefined;
export declare function resolveSchema(this: Ajv, root: SchemaEnv, // root object with properties schema, refs TODO below SchemaEnv is assigned to it
ref: string): SchemaEnv | undefined;
export {};
