"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const codegen_1 = require("../../compile/codegen");
const def = {
    keyword: ["maxItems", "minItems"],
    type: "array",
    schemaType: "number",
    $data: true,
    code(cxt) {
        const { keyword, data, schemaCode } = cxt;
        const op = keyword === "maxItems" ? codegen_1.operators.GT : codegen_1.operators.LT;
        cxt.fail$data(codegen_1._ `${data}.length ${op} ${schemaCode}`);
    },
    error: {
        message({ keyword, schemaCode }) {
            const comp = keyword === "maxItems" ? "more" : "fewer";
            return codegen_1.str `should NOT have ${comp} than ${schemaCode} items`;
        },
        params: ({ schemaCode }) => codegen_1._ `{limit: ${schemaCode}}`,
    },
};
module.exports = def;
//# sourceMappingURL=limitItems.js.map